/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.client.internal.PlanClient");

dojo.require("com.ibm.team.repository.web.transport.ServiceRequest");
dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler");
dojo.require("com.ibm.team.repository.web.transport.TeamServerClient");
dojo.require("com.ibm.team.process.web.client.projectarea");

(function() { // module container

var ServiceRequest 			= com.ibm.team.repository.web.transport.ServiceRequest;
var ServiceResponseHandler 	= com.ibm.team.repository.web.transport.ServiceResponseHandler;
var TeamServerClient 		= com.ibm.team.repository.web.transport.TeamServerClient;

com.ibm.team.workitem.web.client.internal.PlanClient= {

	SERVICE_URI: "com.ibm.team.apt.internal.service.rest.IPlanRestService",

	getWorkItemProgress: function(responseHandler, args) {
		if (!args.itemId) {
			dojo.raise("PlanClient#getWorkItemProgress: missing required param 'itemId'");
		}
		this._invokePlanService(responseHandler, "getWorkItemProgress", args);
	},

	/**
	 * Invokes the requested method on the APT REST service.
	 */
	_invokePlanService: function(responseHandler, method, args) {
		var currentProjectArea = com.ibm.team.process.web.client.projectarea.getCurrentProjectArea();
		var projectAreaArgs= { projectAreaId: currentProjectArea.itemId };
		
		// args is optional, so test whether or not it was sent
		if (arguments.length == 2) {
			var serviceRequest= new com.ibm.team.repository.web.transport.ServiceRequest(
					this.SERVICE_URI,
					method, 
					projectAreaArgs);
		} else {
			serviceRequest= new com.ibm.team.repository.web.transport.ServiceRequest(
					this.SERVICE_URI,
					method,
					dojo.mixin(projectAreaArgs, args));
		}
		com.ibm.team.repository.web.transport.TeamServerClient.invokeService(
				serviceRequest,
				responseHandler);
	}
};

})();