/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
(function(){
	dojo.provide("com.ibm.team.process.web.client.internal.ProcessClient"); //$NON-NLS-1$
	dojo.require("dojo.i18n"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceRequest"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.ServiceResponseHandler"); //$NON-NLS-1$
	dojo.require("com.ibm.team.repository.web.transport.TeamServerClient"); //$NON-NLS-1$
	dojo.requireLocalization("com.ibm.team.process.web.client.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
	// constants and aliases
	var SERVICE_URI = "com.ibm.team.process.internal.common.service.IProcessRestService"; //$NON-NLS-1$
	var ServiceRequest = com.ibm.team.repository.web.transport.ServiceRequest;
	var TeamServerClient = com.ibm.team.repository.web.transport.TeamServerClient;
	
	var ProcessClient = com.ibm.team.process.web.client.internal.ProcessClient;
	
	function getMembersWithReadAccess(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getMembersWithReadAccess", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getMembersWithReadAccess = getMembersWithReadAccess;
	
	function getProcessAreasForUser(kwArgs, responseHandler){
		if (!kwArgs.userId) {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.process.web.client.internal", "Messages"); //$NON-NLS-1$ //$NON-NLS-2$
			alert(dojo.string.substitute(this.messages.ProcessClient_1, [kwArgs.userId]));
			return;
		}
		
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProcessAreasForUser", kwArgs); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProcessAreasForUser = getProcessAreasForUser;
	
	function getAllProjectAreas(responseHandler, args){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getAllProjectAreas", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getAllProjectAreas = getAllProjectAreas;
	
	function getProjectAreaByUUID(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProjectAreaByUUID", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProjectAreaByUUID = getProjectAreaByUUID;
	
	function getPermissionExtensions(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getPermissionExtensions", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getPermissionExtensions = getPermissionExtensions;
	
	function getMembers(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getMembers", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getMembers = getMembers;
	
	function getPermissions(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getPermissions", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getPermissions = getPermissions;
	
	
	function getProjectHierarchy(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProjectHierarchy", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProjectHierarchy = getProjectHierarchy;
	
	function getTeamAreaByUUID(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getTeamAreaByUUID", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getTeamAreaByUUID = getTeamAreaByUUID;
	
	function getProcessAreaHierarchies(responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProcessAreaHierarchies"); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProcessAreaHierarchies = getProcessAreaHierarchies;
	
	function getHierarchyForTeamArea(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getHierarchyForTeamArea", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getHierarchyForTeamArea = getHierarchyForTeamArea;
	
	function getContributors(args, responseHandler){
		if (!args.isLicenseSearch) {
			if (!args.searchTerm) {
				args.searchTerm = "%"; //$NON-NLS-1$
			} else {
				args.searchTerm = "%" + args.searchTerm + "%"; //$NON-NLS-1$ //$NON-NLS-2$
			}
		}
		if (args.pageSize == null) {
			args.pageSize = 50;
		}
		if (args.pageNum == null) {
			args.pageNum = 0;
		}
		if (args.filterOutUsers != null && args.filterOutUsers.length > 0) {
			args.filterOutUsers = dojo.toJson(args.filterOutUsers);
		}
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getContributors", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getContributors = getContributors;
	
	function getPredefinedProcesses(responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getPredefinedProcesses"); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getPredefinedProcesses = getPredefinedProcesses;
	
	function getProcessDefinitions(args, responseHandler) {
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProcessDefinitions", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProcessDefinitions = getProcessDefinitions;
	
	function getProjectDevelopmentLines(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProjectDevelopmentLines", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProjectDevelopmentLines = getProjectDevelopmentLines;
	
	function getIterationTypes(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getIterationTypes", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getIterationTypes = getIterationTypes;
	
	function getIterations(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getIterations", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getIterations = getIterations;
	
	function getTeamAreaIterations(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getTeamAreaIterations", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getTeamAreaIterations = getTeamAreaIterations;
	
	function postProcessDefinition(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postProcessDefinition", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.postProcessDefinition = postProcessDefinition;
	
	function postProjectArea(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postProjectArea", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.postProjectArea = postProjectArea;
	
	function postTeamArea(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postTeamArea", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.postTeamArea = postTeamArea;
	
	function deployPredefinedProcessDefinitions(responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postDeployPredefinedProcessDefinitions"); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.deployPredefinedProcessDefinitions = deployPredefinedProcessDefinitions;
	
	function postArchiveProjectArea(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postArchiveProjectArea", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.postArchiveProjectArea = postArchiveProjectArea;
	
	function getProcessDefinitionById(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "getProcessDefinitionById", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.getProcessDefinitionById = getProcessDefinitionById;
	
	function deleteProcessDefinition(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postDeleteProcessDefinition", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.deleteProcessDefinition = deleteProcessDefinition;
	
	
	function generateTeamInvitations(args, responseHandler){
		var serviceRequest = new ServiceRequest(SERVICE_URI, "postGenerateTeamInvitations", args); //$NON-NLS-1$
		TeamServerClient.invokeService(serviceRequest, responseHandler);
	}
	
	ProcessClient.generateTeamInvitations = generateTeamInvitations;
	
	function stringCompare(s1, s2){
		var string1 = new String(s1);
		var string2 = new String(s2);
		return string1.toLocaleLowerCase().localeCompare(string2.toLocaleLowerCase());
	}
	
	ProcessClient.stringCompare = stringCompare;
})();
