/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.client.internal.query.Term");

(function() {
	
var AND= "AND";
var OR= "OR";

dojo.declare("com.ibm.team.workitem.web.client.internal.query.Term",
	null, {
		
	constructor: function(/* String */ operator) {
		
		var term= new Object();
		term.attributeExpressions= new Array();
		term.termExpressions= new Array();
		term.similarityExpressions= new Array();
		this._term= term;
		
		this.setOperator(operator);
	},
	
	/* String */ serialize: function() {
		return dojo.toJson(this._term);
	},
	
	setOperator: function(operator) {
//		dojo.lang.assert(operator == AND || operator == OR);
		this._term.operator= operator;
	},
	
	addTerm: function(/* Term */ term) {
//		dojo.lang.assert(term._term);
		this._term.termExpressions.push(term._term);
	},
	
	addAttributeExpression: function(/* AttributeExpression */ expression) {
//		dojo.lang.assert(expression);
		this._term.attributeExpressions.push(expression._expr);
	},
	
	addSimilarityExpression: function(/* SimilarityExpression */ expression) {
		this._term.similarityExpressions.push(expression._expr);
	}
	
});

com.ibm.team.workitem.web.client.internal.query.Term.AND= AND;
com.ibm.team.workitem.web.client.internal.query.Term.OR= OR;

})();