/*
 * Licensed Materials - Property of IBM
 * Rational ClearQuest 
 * (C) Copyright IBM Corp. 2009  All Rights Reserved
 * US Government Users Restricted Rights -
 * Use, duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp
 */

dojo.provide("com.ibm.rational.cm.web.ui.ajaxModules.RecordChooserModule");

dojo.require("dijit._Widget");
dojo.require("com.ibm.rational.cm.web._base");
dojo.require("com.ibm.rational.cm.web.ui.view.common.ButtonDialog");
dojo.require("com.ibm.rational.cm.web.ui.view.resultset.ResultSetDialogContent");
dojo.require("com.ibm.rational.cm.web.ui.page.RecordTypeManager");

(function(){

var cq = com.ibm.rational.cm.web;
var recTypeManager = com.ibm.rational.cm.web.ui.page.recTypeManager;

// RATLC01371849 Patch 2009C has name attribute (displayName)
var getDisplayFieldName = function(col){
//	return (col.name) ? col.name : col.field;
	return col.fieldPath;
}

dojo.declare(
	"com.ibm.rational.cm.web.ui.ajaxModules.RecordChooserModule",
	dijit._Widget,
{
	postCreate: function(){
		this._itemPickerNode = this.domNode;
		this._initContentWidget();
		this.setContentWidget(this._btnPane);

		this.inherited(arguments);
		
		this._btnPane.resize({ w:600, h:500 });
		this._btnPane.startup();
	},
	
	onOk: function(){
		var pane = this._btnPane;
		var content = pane.getContent();
		var selected = content.getValues();
		var columnInfo = content.columnInfo;
		
		var indexArray = recTypeManager.getDefaultFields(columnInfo, getDisplayFieldName);
		
		// convert to OSLC-format
		var messageContent = {};
		messageContent["oslc_cm:message"] = "oslc_cm:select";
		messageContent["oslc_cm:results"] = dojo.map(selected, function(sel){
			var obj = {};
			obj["rdf:resource"] = cq.getResourceHref("RECORD", sel.recordId);

			// generate link title			
			var title = "";
			dojo.forEach(indexArray, function(item, idx){
				if(idx > 0){ title += ": "; }
				title += sel[getDisplayFieldName(columnInfo[item])];
			});
			obj["oslc_cm:label"] = title;

			//console.debug("link obj: "+dojo.toJson(obj));
			return obj;
		});
		
		this.close(messageContent);
	},
	
	onCancel: function(){
		var content = {};
		content["oslc_cm:message"] = "oslc_cm:select";
		content["oslc_cm:results"] = [];
		
		this.close(content);
	},

// copied from com.ibm.team.foundation.crossdomain.web.AbstractPickerWidget
// should subclass AbstractPickerWidget once the widget in "C/ALM experimenting" component
// in "C/ALM prototyping" stream gets available
	
createDialog: function(){
	var pane = this._btnPane = new com.ibm.rational.cm.web.ui.view.common.ButtonPane({
		onOk: dojo.hitch(this, "onOk"),
		onCancel: dojo.hitch(this, "onCancel")
	});
	var content = new com.ibm.rational.cm.web.ui.view.resultset.ResultSetDialogContent();
	pane.setContent(content);

	// enable/disable OK button depending on number of selected rows
	var self = this;
	this.connect(content, "onSelectionChanged", function(arr){
		pane.setOkEnabled((arr.length > 0));
	});
	return pane;
},

close: function(result) {
	cq.sendFrameResponse(dojo.toJson(result));
},

getDialogArguments: function() {
    return this.dialogArguments;
},

setContentWidget: function(content) {
    this._itemPickerNode.removeChild(this._itemPickerNode.childNodes[0]);
    this._itemPickerNode.appendChild(content.domNode);
},

_initContentWidget: function() {
    var searchString= location.search.replace(/^\?/, ''); // remove leading '?'
    this.dialogArguments= dojo.queryToObject(searchString);
    
    this.createDialog();
}

});

})();