/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2007, 2009. All Rights Reserved.
 *
 * Note to U.S. Government Users Restricted Rights:  Use,
 * duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.reports.web.ui.internal.ReportParamBoolean");

dojo.require("dojo.i18n");

dojo.require("com.ibm.team.reports.web.ui.internal.ReportParam");

dojo.requireLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");

(function() {
    dojo.declare("com.ibm.team.reports.web.ui.internal.ReportParamBoolean", [com.ibm.team.reports.web.ui.internal.ReportParam], {
        templatePath: dojo.moduleUrl("com.ibm.team.reports.web", "ui/internal/templates/ReportParamBoolean.html"),
		
		constructor: function() {
			this.messages = dojo.i18n.getLocalization("com.ibm.team.reports.web.ui.internal", "ReportMessages");
		},
        
		getSelectedValues: function() {
			return this.optionTrue.selected ? [this.optionTrue.value] : [this.optionFalse.value];
		},
		
		setValues: function(values) {
			if (values == "false") {
				this.optionFalse.selected = true;
			} else if (values == "true") {
				this.optionTrue.selected = true;
			}
		},
		
		setDefaultValues: function() {
			if (this.parameterDTO.defaultValue && this.parameterDTO.defaultValue.length > 0) {
				if (this.parameterDTO.defaultValue == "false") {
					this.optionFalse.selected = true;
				} else if (this.parameterDTO.defaultValue == "true") {
					this.optionTrue.selected = true;
				}
			}
		},
		
		remoteError: function(error) {
			alert(error.message);
		}
		
	});
	
})();
