﻿/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2008. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
 
class Timer {

	private var _startTime:Number;
	
	private var _stopTime:Number;

	private var _displayTag:String;
	
	
	public function Timer(displayTag:String) {
		this._displayTag = displayTag;
	}
	
	public function reset():Void {
		this._startTime = 0;
		this._stopTime = 0;
	}
	
	public function start():Void {
		var date:Date = new Date();
		this._startTime = date.getTime();			
	}
	
	public function stop():Void {
		var date:Date = new Date();
		this._stopTime = date.getTime();
	}
	
	public function getElapsedTime():Number {
		return this._stopTime - this._startTime;
	}
	
	public function getElapsedTimeString():String {
		return this._displayTag + 
				": " +
				String(this.getElapsedTime()) + 
				" ms";
	}
	
	public static function getTimeStamp():String {
		var date:Date = new Date();
		var result:String = String(date.getFullYear()) + 
							"-" +
							String(date.getMonth() + 1) +   
							"-" +
							String(date.getDate()) +
							" " +
							String(date.getHours()) +
							":" +
							String(date.getMinutes()) +
							":" +
							String(date.getSeconds());
		return result;
	}
	
	public function destroy():Void {
		// TODO: Make interface method?
		delete this._startTime;
		delete this._stopTime;
		delete this._displayTag;
	}		
	
}