/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.users.WorkDayLabelProvider"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.internal.ImageClient") //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.viewers.ActionColumnLabelProvider"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.users.dialogs.WorkDayEditDialog"); //$NON-NLS-1$

dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
	
var ImageClient				= com.ibm.team.apt.web.client.internal.ImageClient;
var WorkDayEditDialog		= com.ibm.team.apt.web.ui.internal.users.dialogs.WorkDayEditDialog;

var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
	
dojo.declare("com.ibm.team.apt.web.ui.internal.users.WorkDayLabelProvider", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.viewers.ActionColumnLabelProvider], {
	
	constructor: function() {
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	
	getLabel: function(element, index) {
		if (index == 0) {
			return element.label;
		} else if (index == 1) {
			if (element.workingTime == 0)
				return MSGS.USER_EDITOR_WORK_DAY_NONE;
			
			var hours= element.workingTime / (1000 * 60 * 60);
			return bind(MSGS.USER_EDITOR_WORK_DAY_HOURS, [hours]);
		} else if (index == 2) {
			if (element.workingTime == 0)
				return MSGS.USER_EDITOR_WORK_DAY_NONE;
			
			return dojo.date.locale.format(element.endDate, { selector: "time", formatLength: "short" }); //$NON-NLS-1$ //$NON-NLS-2$
		}
	},
	
	getIcon: function(element, index) {
		if (index == 0) {
			var icon= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/users/images/due_date_obj.gif"); //$NON-NLS-1$ //$NON-NLS-2$
			return ImageClient.getImageUrl(icon);
		}
	},
	
	destroy: function() {
		this.inherited(arguments);
	},
	
	// ---- SPI ------------------------------------------------------------------------------------------------------------
	
	_getActionColumnIndex: function() {
		return 3;
	},
	
	_createActions: function(element) {
		var result= new Array();
		result.push(this.__createEditAction(element));
		return result;
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------
	
	__createEditAction: function(element) {
		return this._createAction(
				MSGS.USER_EDITOR_WORK_DAY_ACTIONS_EDIT_LABEL, 
				ImageClient.getImageUrl(dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/users/images/edit.gif")), //$NON-NLS-1$ //$NON-NLS-2$
				dojo.hitch(this, function() {
					this.__doEdit(element);
				})
		);
	},
	
	
	__doEdit: function(element) {
		var _self= this;
		new WorkDayEditDialog({
			workDay: element,
			onOk: function() {
				element.markChanged();
			},
			onCancel: function() {
			}
		});
	},

	__sentinel: null // terminates this class definition
});

})();
