/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.DeleteAttachedPageAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.PlanningClient"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Action"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {

var ResponseHandler= com.ibm.team.apt.web.client.internal.ProgressMonitoredServiceResponseHandler;	
var PlanningClient= com.ibm.team.apt.web.client.internal.PlanningClient;	


var Assert= com.ibm.team.apt.web.ui.internal.common.Assert;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var IconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/delete.gif"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.DeleteAttachedPageAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.Action], {
	
	_callCtrl: null,
	_pageTab: null,
		
	constructor: function(callCtrl, pageTab) {
		this._callCtrl= callCtrl;
		this._pageTab= pageTab;
	},
	
	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return "attachedPage.delete"; //$NON-NLS-1$
	},
	
	getName: function() {
		return MSGS.ACTION_DELETE_ATTACHED_PAGE;
	},
	
	getIconUrl: function() {
		return IconUrl;
	},
	
	canHandle: function() {
		return this._pageTab instanceof com.ibm.team.apt.web.ui.internal.view.plan.TabAttachedPage && this._pageTab.getPageId() != "overview"; //$NON-NLS-1$
	},
	
	handle: function() {
		
		if(!this.canHandle())
			return;
		
		if(!confirm(MSGS.ACTION_DELETE_ATTACHED_PAGE_CONFIRM))
			return;
	
		var self= this;
		var serviceCallback= {
			_success: function(result) {
				var tab= self._pageTab;
				tab.getPlanPage()._removeAttachedPage(tab.getPageId());
				tab.destroy(true);
			},
			_error: function(error) {
				alert(error);
			}
		};
		var responseHandler= new ResponseHandler(serviceCallback, "_success", "_error"); //$NON-NLS-1$ //$NON-NLS-2$ 
		responseHandler.setLabel(MSGS.MONITOR_DELETE_ATTACHED_PLAN, this._callCtrl);	
		PlanningClient.deleteAttachedPage(responseHandler, this._pageTab.getPlanPage().getPlanId(), this._pageTab.getPageId());
	},

	__sentinel: null // terminates this class definition
});

})();
