/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.NewWorkItemMenuAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.MenuAction"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.NewWorkItemAction"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$=

(function() {
	
var Assert							= com.ibm.team.apt.web.ui.internal.common.Assert;
var NewWorkItemAction				= com.ibm.team.apt.web.ui.internal.view.plan.actions.NewWorkItemAction;

var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var IconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/create_workitem.gif"); //$NON-NLS-1$ //$NON-NLS-2$
	
dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.NewWorkItemMenuAction", //$NON-NLS-1$
		[com.ibm.team.apt.web.ui.internal.view.plan.actions.MenuAction], {
	
	_viewModel: null,
	_itemMovePolicy: null,
	
	constructor: function(viewModel, itemMovePolicy) {
		this._viewModel= viewModel;
		this._itemMovePolicy= itemMovePolicy;
	},

	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getName: function() {
		return MSGS.ACTION_NEW_WORK_ITEM;
	},
	
	getId: function() {
		return "new.planitem"; //$NON-NLS-1$
	},
	
	getIconUrl: function() {
		return IconUrl;
	},
	
	createActions: function() {
		var result= [];
		
		var plan= this._viewModel.getInput();
		var types= plan.getCreatableWorkItemTypes();
		
		for ( var i = 0; i < types.length; i++) {
			var type= types[i];
			result.push(this._createNewWorkItemAction(type));	
		}
		return result;
	},
	
	canHandle: function(target, selection) {
		return true;
	},
	
	handle: function(target, selection) {
	},
	
	// ---- SPI ------------------------------------
	
	_createNewWorkItemAction: function(type) {
		return new NewWorkItemAction(this._viewModel, type, this._itemMovePolicy);
	},

	// ---- widget implementation ------------------------------------------------------------------------------------------

	__sentinel: null // terminates this class definition
});

})();
