/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.actions.PlanEditModeAction"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.InputDialog"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.TabAttachedPage"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.common.Assert"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.plan.actions.Action"); //$NON-NLS-1$

dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
dojo.require("dojo.i18n"); //$NON-NLS-1$

(function() {

var Action= com.ibm.team.apt.web.ui.internal.view.plan.actions.Action;
var Assert= com.ibm.team.apt.web.ui.internal.common.Assert;

var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var IconUrl= dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/images/edit.gif"); //$NON-NLS-1$ //$NON-NLS-2$

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.actions.PlanEditModeAction", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.plan.actions.Action], {

	_viewer: null,
	_checked: null,
	
	// ---- constructor mixed-in properties --------------------------------------------------------------------------------	

	constructor: function(viewer) {
		this._viewer= viewer;
		this._checked= false;
	},
	
	// ---- api ------------------------------------------------------------------------------------------------------------
	
	getId: function() {
		return "plan.editMode"; //$NON-NLS-1$
	},
	
	getName: function() {
		return MSGS.ACTION_PLAN_EDIT_MODE; //$NON-NLS-1$
	},
	
	getStyle: function() {
		return Action.STYLE_FLAT | Action.STYLE_TOGGLE;
	},
	
	getIconUrl: function() {
		return IconUrl;
	},
	
	isChecked: function() {
		return this._checked;
	},
	
	canHandle: function() {
		return true;
	},
	
	handle: function(e) {
		this._checked= !this._checked;
		this._viewer.enableEditMode(this._checked);
	},

	__sentinel: null // terminates this class definition
});

})();
