/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.DurationSelectionDialog"); //$NON-NLS-1$

dojo.require("jazz.ui.Dialog"); //$NON-NLS-1$
dojo.require("dijit._Widget"); //$NON-NLS-1$
dojo.require("dijit._Templated"); //$NON-NLS-1$
dojo.require("dijit.form.TimeTextBox"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {
	
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$
var bind= dojo.string.substitute;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.DurationSelectionDialog", null, { //$NON-NLS-1$
	
	constructor: function(params){
		var widgetParams = { primaryTitle: MSGS.DIALOGS_DURATION_SELECTION_TITLE, width: "25em" }; //$NON-NLS-1$

		var onOk= dojo.hitch(this, function(value) {
			this.floatingPane.close();
			params.onOk(value);
		});
		
		var onCancel= dojo.hitch(this, function() {
			this.floatingPane.close();
			if (params.onCancel)
				params.onCancel();
		}); 
		
		this.contentWidget= new com.ibm.team.apt.web.ui.internal.view.plan.dialogs.DurationSelectionDialogContent({
			onOk: onOk,  
			onCancel: onCancel,
			value: params.value
		});
		widgetParams.contentNode = this.contentWidget.domNode;
		this.floatingPane = new jazz.ui.Dialog(widgetParams); 
		this.contentWidget.init();
	}
	
});

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.dialogs.DurationSelectionDialogContent", //$NON-NLS-1$
	[dijit._Widget, dijit._Templated], {
					
	templatePath: dojo.moduleUrl("com.ibm.team.apt.web", "ui/internal/view/plan/dialogs/templates/DurationSelectionDialogContent.html"), //$NON-NLS-1$ //$NON-NLS-2$
					
	__okOk: null,
	__onCancel: null,
	__value: null,
	
	__messages: MSGS,
	
	constructor: function(params){
		this.__value= params.value;	
		this.__onOk= params.onOk;
		this.__onCancel= params.onCancel;
	},
	
	postCreate: function() {
		this.connect(this._okCmd, "onclick", dojo.hitch(this, function() { //$NON-NLS-1$
			var value= parseFloat(this._input.value);
			value= value * (1000 * 60 * 60);
			value= Math.round(value);
			this.__onOk(new com.ibm.team.apt.client.Duration(value));
		}));
		this.connect(this._cancelCmd, "onclick", this.__onCancel); //$NON-NLS-1$
		
		this._input.value= this.__value.getMilliseconds() / (1000 * 60 * 60);
		this.connect(this._input, "onkeypress", dojo.hitch(this, function(e) { //$NON-NLS-1$
			this.__updateState(this._input.value + e.keyChar);
		}));
		
		this._okCmd.disabled= true;
	},
	
	init: function() {
	},
	
	__updateState: function(inputValue) {
		this._okCmd.disabled= true;
		
		try {
			var value= parseFloat(inputValue);
			if (value != inputValue)
				return
			
			if (value < 0)
				return;
			
			this._okCmd.disabled= false;
		} catch (e) {
			return;
		}
	},
	
	__sentinel: null
});

})();
