/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.GroupElementViewerItem"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.ui.internal.view.widgets.ProgressBar"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.client.util"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.PlanningClient"); //$NON-NLS-1$

dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var doc= document;
var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var ViewModelViewerItem				= com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem;

var PlanningUtil= com.ibm.team.apt.web.client.util;
var PlanningClient= com.ibm.team.apt.web.client.internal.PlanningClient;

var ProgressBar= com.ibm.team.apt.web.ui.internal.view.widgets.ProgressBar;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.GroupElementViewerItem", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem], {

	_groupElement: null,
	__actionBar: null,
	
	__groupContent: null,
		
	__progressInformation: null,
	__progressLabelProvider: null,
	
	constructor: function(entry, parentItem, plannedItemsTab, viewer) {
		this._groupElement= entry.getElement();
	},

	// ---- ViewModelViewerItem implementation -----------------------------------------------------------------------------

	_createContainer: function() {
		var result= doc.createElement("tr"); //$NON-NLS-1$
		dojo.addClass(result, "group"); //$NON-NLS-1$
		return result;
	},

	_createContent: function() {
		var localDoc= doc;

		var actionCell=localDoc.createElement("td"); //$NON-NLS-1$
		dojo.addClass(actionCell, "groupTd"); //$NON-NLS-1$
		dojo.addClass(actionCell, "actionBarCell"); //$NON-NLS-1$
		this.domNode.appendChild(actionCell);
		
		var actionContent=localDoc.createElement("div"); //$NON-NLS-1$
		dojo.addClass(actionContent, "content"); //$NON-NLS-1$
		actionCell.appendChild(actionContent);
		
		var actionBar= this._createActionBar();
		actionContent.appendChild(actionBar.domNode);

		var cell= localDoc.createElement("td"); //$NON-NLS-1$
		cell.colSpan= 100;
		dojo.addClass(cell, "groupTd"); //$NON-NLS-1$

		this.__groupContent= localDoc.createElement("div"); //$NON-NLS-1$
		dojo.addClass(this.__groupContent, "content"); //$NON-NLS-1$
		dojo.addClass(this.__groupContent, "label"); //$NON-NLS-1$

		var progressElement= localDoc.createElement("div"); //$NON-NLS-1$
		dojo.addClass(progressElement, "bar"); //$NON-NLS-1$
		
		switch(this._plannedItemsTab.getPlanMode().barMode.id) {
			case "PROGRESS": //$NON-NLS-1$
				this.__calculateProgress();
				var barElement=localDoc.createElement("div"); //$NON-NLS-1$
				progressElement.appendChild(barElement);
				var constructorArgs= ProgressBar.constructorArgs(this.__progressInformation, this.__progressLabelProvider); //$NON-NLS-1$ //$NON-NLS-2$
				var progress= new ProgressBar(constructorArgs, barElement);
				
				var lblProgressText= localDoc.createElement("span"); //$NON-NLS-1$
				dojo.addClass(lblProgressText, "numbers"); //$NON-NLS-1$
				dojo.addClass(lblProgressText, "hours"); //$NON-NLS-1$
				lblProgressText.innerHTML= this.__progressLabelProvider.getProgressText(this.__progressInformation);
				progressElement.appendChild(lblProgressText);
				
				var lblQualityText= localDoc.createElement("span"); //$NON-NLS-1$
				dojo.addClass(lblQualityText, "numbers"); //$NON-NLS-1$
				dojo.addClass(lblQualityText, "estimate"); //$NON-NLS-1$
				lblQualityText.innerHTML= this.__progressLabelProvider.getQualityText(this.__progressInformation);
				progressElement.appendChild(lblQualityText);
				break;
				
			case "LOAD": //$NON-NLS-1$
				if(dojo.indexOf(this._entry.getModel().getInput().getTeamMembers(), this._entry.getElement().getValue()) != -1){
					this.__calculateLoad();
					var barElement=localDoc.createElement("div"); //$NON-NLS-1$
					progressElement.appendChild(barElement);
					var constructorArgs= ProgressBar.constructorArgs(this.__progressInformation, this.__progressLabelProvider); //$NON-NLS-1$ //$NON-NLS-2$
					var progress= new ProgressBar(constructorArgs, barElement);
					
					var lblProgressText= localDoc.createElement("span"); //$NON-NLS-1$
					dojo.addClass(lblProgressText, "numbers"); //$NON-NLS-1$
					dojo.addClass(lblProgressText, "hours"); //$NON-NLS-1$
					lblProgressText.innerHTML= this.__progressLabelProvider.getProgressText(this.__progressInformation);
					progressElement.appendChild(lblProgressText);
					
					var lblQualityText= localDoc.createElement("span"); //$NON-NLS-1$
					dojo.addClass(lblQualityText, "numbers"); //$NON-NLS-1$
					dojo.addClass(lblQualityText, "estimate"); //$NON-NLS-1$
					lblQualityText.innerHTML= this.__progressLabelProvider.getQualityText(this.__progressInformation);
					progressElement.appendChild(lblQualityText);
				} else {
					this.__calculateCounts();
				}
				break;
				
			case "NONE": //$NON-NLS-1$
				this.__calculateCounts();
				break;
		}

		this.__groupContent.appendChild(progressElement);
		
		var groupImageNode= this._createGroupImageNode();
		if (groupImageNode != null) {
			this.__groupContent.appendChild(groupImageNode);
		}
		
		var groupTextContainer= localDoc.createElement("div"); //$NON-NLS-1$
		dojo.addClass(groupTextContainer, "labelContainer"); //$NON-NLS-1$
		
		var titleElement= localDoc.createElement("div"); //$NON-NLS-1$
		dojo.addClass(titleElement, "title"); //$NON-NLS-1$
		titleElement.appendChild(localDoc.createTextNode(this._groupElement.getLabel()));
		groupTextContainer.appendChild(titleElement);
		
		var countElement= localDoc.createElement("div"); //$NON-NLS-1$
		dojo.addClass(countElement, "counts"); //$NON-NLS-1$
		countElement.appendChild(localDoc.createTextNode(bind(MSGS.GROUPWIDGET_COUNTS, [this.__progressInformation.getCloseCount(), this.__progressInformation.getOpenCount()])));
		groupTextContainer.appendChild(countElement);
		
		this.__groupContent.appendChild(groupTextContainer);
		cell.appendChild(this.__groupContent);

		this.domNode.appendChild(cell);

		this._applyTreeLayout(cell);
	},
	
	_createGroupImageNode: function() {
		return null;
	},
	
	_getTreeLayoutElement: function() {
		return this.__groupContent;
	},

	// ---- implementation -------------------------------------------------------------------------------------------------
		
	__calculateCounts: function() {
		PlanningUtil.runWithCondition(dojo.hitch(this, function() {
			this.__progressInformation= new com.ibm.team.apt.internal.ui.progress.ProgressInformation();
			this._entry.getModel().readModel(dojo.hitch(this, function(readAccessor){
				var entryItemAccessor= new com.ibm.team.apt.ui.structure.OutlineEntryItemAccessor(readAccessor, null);
				var progressComputor= new com.ibm.team.apt.internal.ui.progress.ProgressComputer(entryItemAccessor, this.__progressInformation);
				progressComputor.compute(this._entry);
			}));
		}), PlanningClient.getScriptsLoadedCondition());
	},
	
	__calculateProgress: function() {
		PlanningUtil.runWithCondition(dojo.hitch(this, function() {
			
			var planProgress= this._entry.getModel().getInput().getPlanProgress();	
			var complexityAttr= planProgress.complexityAttribute;
			var options= {};
			options.parameters= {};
			if(complexityAttr){
				options.parameters["complexityLabel"]= complexityAttr.label; //$NON-NLS-1$
				options.parameters["complexityUnit"]= complexityAttr.unit; //$NON-NLS-1$
			}
			
			var labelProviderCtor= dojo.getObject(planProgress.labelProviderImplementation);
			this.__progressLabelProvider= new labelProviderCtor(options);
		
			this.__progressInformation= new com.ibm.team.apt.internal.ui.progress.ProgressInformation();
			this._entry.getModel().readModel(dojo.hitch(this, function(readAccessor){
				var entryItemAccessor= new com.ibm.team.apt.ui.structure.OutlineEntryItemAccessor(readAccessor, complexityAttr ? complexityAttr.attributeId : null);
				var computerCtor= dojo.getObject(planProgress.computerImplementation);
				var progressComputor= new computerCtor(entryItemAccessor, this.__progressInformation);
				progressComputor.compute(this._entry);
			}));
			
			var itemSequenceMgr= this._entry.getModel().getInput().getItemSequenceManager(this._entry.getElement().getValue());
			if(itemSequenceMgr) {
				var totalWorkTime= itemSequenceMgr.getTotalWorkTime();
				var remainingWorkTime= itemSequenceMgr.getRemainingWorkTime();
				this.__progressInformation.deltaRealTimeDone(Math.max(0, totalWorkTime - remainingWorkTime));
				this.__progressInformation.deltaRealTimeLeft(remainingWorkTime);
			}
			
		}), PlanningClient.getScriptsLoadedCondition());
	},

	__calculateLoad: function() {
		PlanningUtil.runWithCondition(dojo.hitch(this, function() {
			this.__progressInformation= new com.ibm.team.apt.internal.ui.progress.ProgressInformation();
			var itemSequenceMgr= this._entry.getModel().getInput().getItemSequenceManager(this._entry.getElement().getValue());
			if(itemSequenceMgr) {
				this.__progressInformation.deltaRealTimeLeft(itemSequenceMgr.getRemainingWorkTime());
			}
			this.__progressLabelProvider= new com.ibm.team.apt.internal.ui.load.LoadLabelProvider();
			this._entry.getModel().readModel(dojo.hitch(this, function(readAccessor){
				var entryItemAccessor= new com.ibm.team.apt.ui.structure.OutlineEntryItemAccessor(readAccessor, null);
				var progressComputor= new com.ibm.team.apt.internal.ui.load.LoadComputer(entryItemAccessor, this.__progressInformation);
				progressComputor.compute(this._entry);
			}));
			return true;
			
		}), PlanningClient.getScriptsLoadedCondition());
	},

	__sentinel: null // terminates this class definition
});

})();
