/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.OutOfOfficeItemViewerItem"); //$NON-NLS-1$

dojo.require("com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.internal.ImageClient"); //$NON-NLS-1$
dojo.require("com.ibm.team.apt.web.client.util"); //$NON-NLS-1$

dojo.require("dojo.date.locale"); //$NON-NLS-1$
dojo.require("dojo.string"); //$NON-NLS-1$
dojo.require("dojo.i18n"); //$NON-NLS-1$
dojo.requireLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

(function() {

var doc= document;
var bind= dojo.string.substitute;
var MSGS= dojo.i18n.getLocalization("com.ibm.team.apt.web.ui.internal", "IterationPlanMessages"); //$NON-NLS-1$ //$NON-NLS-2$

var ImageClient						= com.ibm.team.apt.web.client.internal.ImageClient;
var ViewModelViewerItem				= com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem;
var PlanningUtil					= com.ibm.team.apt.web.client.util;

dojo.declare("com.ibm.team.apt.web.ui.internal.view.plan.planneditems.OutOfOfficeItemViewerItem", //$NON-NLS-1$
			 [com.ibm.team.apt.web.ui.internal.view.common.ViewModelViewerItem], {

	__outOfOfficeItem: null,
	__treeLayoutElement: null,

	constructor: function(entry, parentItem, plannedItemsTab, viewer) {
		this.__outOfOfficeItem= entry.getElement();
	},

	// ---- ViewModelViewerItem implementation -----------------------------------------------------------------------------

	_createContainer: function() {
		var result= doc.createElement("tr"); //$NON-NLS-1$
		dojo.addClass(result, "outOfOffice"); //$NON-NLS-1$
		return result;
	},

	_createContent: function() {
		var localDoc= doc;
		var rowContainer= this.domNode;
		
		var actionBarCell=localDoc.createElement("td"); //$NON-NLS-1$
		dojo.addClass(actionBarCell, "actionBarCell"); //$NON-NLS-1$
		var actionBar= this._createActionBar();
		actionBarCell.appendChild(actionBar.domNode);
		rowContainer.appendChild(actionBarCell);

		var markerCell= localDoc.createElement("td"); //$NON-NLS-1$
		dojo.addClass(markerCell, "info"); //$NON-NLS-1$
		rowContainer.appendChild(markerCell);

		var cell= localDoc.createElement("td"); //$NON-NLS-1$
		dojo.addClass(cell, "attribute"); //$NON-NLS-1$
		dojo.addClass(cell, "summary"); //$NON-NLS-1$
		this.__treeLayoutElement= cell;
		
		var iconContainer= localDoc.createElement("div"); //$NON-NLS-1$
		dojo.addClass(iconContainer, "icon"); //$NON-NLS-1$
		
		var iconElement= localDoc.createElement("img"); //$NON-NLS-1$
		dojo.addClass(iconElement, "typeIcon"); //$NON-NLS-1$
		iconElement.src= ImageClient.getImageUrl(this.__outOfOfficeItem.getIconUrl());
		iconContainer.appendChild(iconElement);

		cell.appendChild(iconContainer);
	
		var summaryElement= localDoc.createElement("div"); //$NON-NLS-1$
		dojo.addClass(summaryElement, "summary"); //$NON-NLS-1$
		summaryElement.appendChild(localDoc.createTextNode(this.__outOfOfficeItem.getSummary()));
		cell.appendChild(summaryElement);

		var detailElement= localDoc.createElement("div"); //$NON-NLS-1$
		dojo.addClass(detailElement, "detail"); //$NON-NLS-1$
		var outOfOfficeDetails= bind(MSGS.PLANNEDITEMS_OUTOFOFFICE, [
		    dojo.date.locale.format(this.__outOfOfficeItem.getStart().getDate(), { selector: "date", formatLength: "medium" }), //$NON-NLS-1$ //$NON-NLS-2$
		    dojo.date.locale.format(this.__outOfOfficeItem.getEnd().getDate(), { selector: "date", formatLength: "medium" })]); //$NON-NLS-1$ //$NON-NLS-2$
		detailElement.appendChild(localDoc.createTextNode(outOfOfficeDetails));
		cell.appendChild(detailElement);

		rowContainer.appendChild(cell);

		dojo.toggleClass(rowContainer, "placeholder", false); //$NON-NLS-1$
		dojo.toggleClass(rowContainer, "auxiliary", false); //$NON-NLS-1$
		dojo.toggleClass(rowContainer, "resolved", this.__outOfOfficeItem.isResolved()); //$NON-NLS-1$
	
		this._applyTreeLayout();
	},

	_getTreeLayoutElement: function() {
		return this.__treeLayoutElement;
	},

	__sentinel: null // terminates this class definition
});

})();
