/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.workitem.web.ui.internal.view.queryeditor.ErrorLabel");

dojo.require("dojox.data.dom");
dojo.require("jazz.ui.HoverPopup");
dojo.requireLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages");
dojo.require("dijit._Widget");
dojo.require("dijit._Templated");

(function() {
	
dojo.declare("com.ibm.team.workitem.web.ui.internal.view.queryeditor.ErrorLabel",
	[dijit._Widget, dijit._Templated], {
	
	///////////////////////////////////////////////////////////////////////////////////
	// Called on creation
	templateString: "<div><div dojoAttachpoint='_errorElement'></div></div>",
	constructor: function(args) {
		this.messages = dojo.i18n.getLocalization("com.ibm.team.workitem.web.ui.internal", "QueryMessages");
	},
	
	postCreate: function() {
		this._messageSpan= document.createElement("span");
		this._errorElement.appendChild(this._messageSpan);
	    this._toolTip=new jazz.ui.HoverPopup({ around: [ this._messageSpan ]});
		this.clearError();
	},
	destroy: function() {
		if(this._toolTip && this._toolTip.destroy) this._toolTip.destroy();
	},
	
	///////////////////////////////////////////////////////////////////////////////////
	// API
	
	showError: function(message, error) {
		dojox.data.dom.replaceChildren(this._messageSpan, document.createTextNode(message));
		this._toolTip.html= error.message ? error.message : this.messages.errorNoDetailsAvailable ;
		this._errorElement.style.display= "";
	},
	
	clearError: function() {
		this._errorElement.style.display= "none";
	}
	
});

})();
