/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005-2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.client.internal.Timespan"); //$NON-NLS-1$

dojo.require("com.ibm.team.foundation.Assert"); //$NON-NLS-1$

(function() {

var Assert							= com.ibm.team.foundation.Assert;

dojo.declare("com.ibm.team.apt.client.internal.Timespan", null, { //$NON-NLS-1$

	constructor: function(start, end, segments) {
		Assert.isLegal(start <= end);
		this.start= start;
		this.end= end;

		segments= segments || [ this ];
		Assert.isLegal(start.equals(segments[0].start));
		Assert.isLegal(end.equals(segments[segments.length - 1].end));
		
		this.segments= segments;
	},

	// ---- api ------------------------------------------------------------------------------------------------------------
	
	start: null,
	end: null,
	segments: null,

	contains: function(instant) {
		return this.start.beforeEq(instant) && this.end.after(instant);
	},

	compareTo: function(other) {
		return this.__comparisonValue() - other.__comparisonValue();
	},

	equals: function(other) {
		if (this === other)
			return true;

		if (this.declaredClass !== other.declaredClass)
			return false;

		return this.start.equals(other.start) && this.end.equals(other.end);
	},

	// ---- implementation -------------------------------------------------------------------------------------------------

	__comparisonValue: function() {
		var start= this.start.getDate().getTime();
		var end= this.end.getDate().getTime();
		return (end - start) / 2 + start;
	},
	
	__sentinel: null // terminates this class definition
});

})();
