/*******************************************************************************
 * Licensed Materials - Property of IBM
 * (c) Copyright IBM Corporation 2005, 2009. All Rights Reserved.
 * 
 * Note to U.S. Government Users Restricted Rights:
 * Use, duplication or disclosure restricted by GSA ADP Schedule
 * Contract with IBM Corp.
 *******************************************************************************/
dojo.provide("com.ibm.team.apt.ui.model.OptionsStore"); //$NON-NLS-1$

(function() {

dojo.declare("com.ibm.team.apt.ui.model.OptionsStore", null, { //$NON-NLS-1$

	__store: null,
	__subStores: null,

	constructor: function(store) {
		this.__store= store;
	},
	
	// ---- API ------------------------------------------------------------------------------------------------------------

	load: function() {
		return this.__store;
	},

	store: function(value) {
		this.__store= value;
	},

	subStore: function(name) {
		if (this.__subStores && this.__subStores[name])
			return this.__subStores[name];

		var subStoreContent= this.__store[name] || {};
		
		var result= new com.ibm.team.apt.ui.model.OptionsStore(subStoreContent);
		
		if (!this.__subStores) {
			this.__subStores= {};
		}
		this.__subStores[name]= result;
		return result;
	},

	markDirty: function() {
	},
	
	serialize: function() {
		return dojo.toJson(this.__getUpdatedStore());
	},
	
	// ---- implementation -------------------------------------------------------------------------------------------------

	__getUpdatedStore: function() {
		if (this.__subStores) {
			for (var storeName in this.__subStores) {
				this.__store[storeName]= this.__subStores[storeName].__getUpdatedStore();
			}
		}
		return this.__store;
	},

	__sentinel: null // terminates this class definition
});


})();
